/////////////////////////////////////////////////////////////////////////////
// ListBoxControlX.h : Declaration of the CListBoxControlX
//
// Ownerdrawn Superclassed ListBox ActiveX Control
//
// All rights reserved.
//
// Written by Naveen Kohli (naveen@a3ds.com)
// Version 1.0
//
// Distribute freely, except: don't remove my name from the source or
// documentation (don't take credit for my work), mark your changes (don't
// get me blamed for your possible bugs), don't alter or remove this
// notice.
// No warrantee of any kind, express or implied, is included with this
// software; use at your own risk, responsibility for damages (if any) to
// anyone resulting from the use of this software rests entirely with the
// user.
//
// Send bug reports, bug fixes, enhancements, requests, flames, etc. to
//    naveen@a3ds.com
/////////////////////////////////////////////////////////////////////////////

#ifndef __LISTBOXCONTROLX_H_
#define __LISTBOXCONTROLX_H_

#include "resource.h"
#include <atlctl.h>
#include "ATLListControlCP.h"

typedef vector<long> LONGVECTOR;
/////////////////////////////////////////////////////////////////////////////
// CListBoxControlX
class ATL_NO_VTABLE CListBoxControlX : 
	// COM object support
	public CComObjectRootEx<CComSingleThreadModel>,
	// Request for properties preprocessed by stock property base class
	public CStockPropImpl<CListBoxControlX, IListBoxControlX, &IID_IListBoxControlX,
		&LIBID_ATLLISTCONTROLLib>,
	// Control persistence implenetation
	public IPersistStreamInitImpl<CListBoxControlX>,
	public IPersistStorageImpl<CListBoxControlX>,
    public IPersistPropertyBagImpl<CListBoxControlX>,
	// Basic control implementation
	public CComControl<CListBoxControlX>,
	public IOleControlImpl<CListBoxControlX>,
	public IOleObjectImpl<CListBoxControlX>,
	public IOleInPlaceActiveObjectImpl<CListBoxControlX>,
	public IViewObjectExImpl<CListBoxControlX>,
	public IOleInPlaceObjectWindowlessImpl<CListBoxControlX>,
	// Error info support for default dual interface
	public ISupportErrorInfo,
	// Support for peoperty pages
	public ISpecifyPropertyPagesImpl<CListBoxControlX>,
	public IQuickActivateImpl<CListBoxControlX>,
	// Support for OLE embedding
	public IDataObjectImpl<CListBoxControlX>,
	// Connection point implementation
	public IConnectionPointContainerImpl<CListBoxControlX>,
	public IProvideClassInfo2Impl<&CLSID_ListBoxControlX, &DIID__IListBoxControlXEvents,
		&LIBID_ATLLISTCONTROLLib>,
	// Full controls supoorting connection points also recieve proprty change
	// notification support
	public IPropertyNotifySinkCP<CListBoxControlX>,
	// Class object support
	public CComCoClass<CListBoxControlX, &CLSID_ListBoxControlX>,
	public CProxy_IListBoxControlXEvents< CListBoxControlX >,
	// Object safety interface support
	public IObjectSafetyImpl<CListBoxControlX, INTERFACESAFE_FOR_UNTRUSTED_CALLER |
										INTERFACESAFE_FOR_UNTRUSTED_DATA>
{
public:
	CContainedWindow m_ctlListBox;

	CListBoxControlX();

DECLARE_REGISTRY_RESOURCEID(IDR_LISTBOXCONTROLX)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CListBoxControlX)
	COM_INTERFACE_ENTRY(IListBoxControlX)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IPersistPropertyBag)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IObjectSafety)
END_COM_MAP()

BEGIN_PROP_MAP(CListBoxControlX)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("Font", DISPID_FONT, CLSID_StockFontPage)
	PROP_ENTRY("DividerLine Color", DISPID_DIVIDERLINECOLOR, CLSID_StockColorPage)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CListBoxControlX)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
	CONNECTION_POINT_ENTRY(DIID__IListBoxControlXEvents)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CListBoxControlX)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_DRAWITEM, OnDrawItem)
	MESSAGE_HANDLER(WM_COMMAND, OnSelectionChange)
	CHAIN_MSG_MAP(CComControl<CListBoxControlX>)
	DEFAULT_REFLECTION_HANDLER ()
ALT_MSG_MAP(1)
	// Replace this with message map entries for superclassed ListBox
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	HRESULT FinalConstruct ();

	HRESULT OnDraw(ATL_DRAWINFO& di);
	LRESULT OnDrawItem(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnSelectionChange(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	BOOL PreTranslateAccelerator(LPMSG pMsg, HRESULT& hRet);
	LRESULT OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	STDMETHOD(SetObjectRects)(LPCRECT prcPos,LPCRECT prcClip);

// IObjectSafety
	STDMETHOD(GetInterfaceSafetyOptions)(REFIID riid, DWORD *pdwSupportedOptions,
		DWORD *pdwEnabledOptions);

	STDMETHOD(SetInterfaceSafetyOptions)(REFIID riid, DWORD dwOptionSetMask,
		DWORD dwEnabledOptions);
// IOleControl
	STDMETHOD(OnAmbientPropertyChange)(DISPID dispid);

// CComControlBase
	HRESULT IQuickActivate_QuickActivate (QACONTAINER *pQACont, QACONTROL *pQACtrl);
	HRESULT IPersistStreamInit_Load(LPSTREAM pStm, ATL_PROPMAP_ENTRY* pMap);
    HRESULT IPersistStreamInit_Save(LPSTREAM pStm, BOOL fClearDirty, ATL_PROPMAP_ENTRY* pMap);
    HRESULT IPersistPropertyBag_Load(LPPROPERTYBAG pPropBag, LPERRORLOG pErrorLog, ATL_PROPMAP_ENTRY* pMap);
    HRESULT IPersistPropertyBag_Save(LPPROPERTYBAG pPropBag, BOOL fClearDirty, BOOL fSaveAllProperties, ATL_PROPMAP_ENTRY* pMap);

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IListBoxControlX
public:
	STDMETHOD(get_DividerLineColor)(/*[out, retval]*/ OLE_COLOR *pVal);
	STDMETHOD(put_DividerLineColor)(/*[in]*/ OLE_COLOR newVal);
	STDMETHOD(GetCount)(/*[out]*/ long *plNumItems);
	STDMETHOD(FindString)(/*[in]*/ long lIndexAfter, /*[in]*/ BSTR bstrItem, /*[out]*/ long *plRetIndex);
	STDMETHOD(ResetContent)();
	STDMETHOD(DeleteString)(/*[in]*/ long lIndex, /*[out]*/ long *plNumItems);
	STDMETHOD(InsertString)(/*[in]*/ long lIndex, /*[in]*/ BSTR bstrItem, /*[out]*/ long *plRetPos);
	STDMETHOD(RemoveDividerIndex)(/*[in]*/ long lIndex, /*[out]*/ long *plRetPos);
	STDMETHOD(AddDividerIndex)(/*[in]*/ long lIndex);
	STDMETHOD(SetCurSel)(/*[in]*/ long lIndex);
	STDMETHOD(GetCurSel)(/*[out]*/ long *plIndex);
	STDMETHOD(AddString)(/*[in]*/ BSTR bstrItem);

	CComPtr<IFontDisp> m_pFont;
	OLE_COLOR m_clrDividerLineColor;
	LONGVECTOR m_DividerIdxVect;

private:
	long NumDividers () const;
	long GetDividerAtPos (long lIndex) const;
	void RemoveAllIndices ();
	long FindDividerIndex (long lIndex);
	long FindPrevDividerIndex (long lSel) const;
};

#endif //__LISTBOXCONTROLX_H_
