// ListcClientDlg.cpp : Implementation of CListcClientDlg
#include "stdafx.h"
#include "ListcClientDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CListcClientDlg

/////////////////////////////////////////////////////////////////////////////
// CClientDlg
//
//	Function:
//		CClientDlg()
//
//	Parameters;
//
//	Return Values:
//
//	Comments:
//		Class constructor..
//

CListcClientDlg::CListcClientDlg()
{

}

//
//	Function:
//		OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
//
//	Parameters;
//
//	Return Values:
//		S_OK	Successful property page intialization
//		E_FAIL	Error in property page intialization
//
//	Comments:
//		Function handles the dialog box intialization.
//

LRESULT
CListcClientDlg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	HRESULT hr = E_FAIL;

	// Cache the pointer to shape control.

	m_XListBoxCtlWnd = GetDlgItem (IDC_LISTBOXCONTROLX);
	m_hSelectIndexStatic = GetDlgItem (IDC_SELECT_STATIC);

	// Get the unknown pointer.
	
	AtlAxGetControl (m_XListBoxCtlWnd, (IUnknown **) &m_pXListBoxCtl);

	// Make the connecton to control's IControlContainer interface.

	AtlAdviseSinkMap (this, TRUE);

	CComBSTR bstrItem = _T ("A");

	m_pXListBoxCtl->AddDividerIndex (2);
	m_pXListBoxCtl->AddDividerIndex (10);
	m_pXListBoxCtl->AddDividerIndex (20);

	for (int i = 0; i < 26; i++) {
		m_pXListBoxCtl->AddString (bstrItem.Copy ());
	}

	m_pXListBoxCtl->SetCurSel (1);

	return 1;  // Let the system set the focus
}

//
//	Function:
//		OnOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
//
//	Parameters;
//
//	Return Values:
//		S_OK	Successful property page intialization
//		E_FAIL	Error in property page intialization
//
//	Comments:
//		Function handles the click on OK button.
//

LRESULT
CListcClientDlg::OnOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	AtlAdviseSinkMap (this, FALSE);
	DestroyWindow ();
	PostQuitMessage (0);
	return 0;
}

//
//	Function:
//		OnCancel (WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
//
//	Parameters;
//
//	Return Values:
//		S_OK	Successful property page intialization
//		E_FAIL	Error in property page intialization
//
//	Comments:
//		Function handles the click on Close button.
//

LRESULT
CListcClientDlg::OnCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	AtlAdviseSinkMap (this, FALSE);
	DestroyWindow ();
	PostQuitMessage (0);
	return 0;
}

//
//	Function:
//		VOID OnSelectionChangeListboxcontrolx ()
//
//	Parameters;
//
//	Return Values:
//
//	Comments:
//		Function handles the selection change in list box control. This event is fired by
//		the control when user clicks in list box to change the current selection.
//		The dialog box captures this message by the IDispatch interface implemented by container.
//

VOID __stdcall
CListcClientDlg::OnSelectionChangeListboxcontrolx ()
{
	long selection;
	char buffer[3];

	m_pXListBoxCtl->GetCurSel (&selection);

	if (selection >= 0) {
		sprintf (buffer, "%d", (int)selection);
		::SetWindowText (m_hSelectIndexStatic, buffer);
	}
	
}